/*
 * dx.c -- 2HD(8sec) x^C[Wt@Cwt@C𒊏o܂
 * dx.c,v 1.4 1995-05-02 04:01:06+0900 kyoko Exp
 * Copyright (C) 1995 fubuki
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Ԃqɂ:
 *
 * version 1.4 patchlevel 1
 *	2HQ ̃x^t@CɑΉA.
 * version 1.4 patchlevel 2
 *	2HD  DCU ɑΉ.
 *	ʎq LARGE_BUFFER `̓t@C I/O obt@
 *	g傷悤ɂ.
 *
 */


#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <time.h>
#include  <utime.h>
#include  <ctype.h>
#include  <mbctype.h>
#include  <signal.h>
#include  <unistd.h>
#include  <errno.h>
#include  <sys/dos.h>
#include  <sys/stat.h>

/* 1998/09/03 : twoncall.h Ή */
#ifdef	HAVE_TWONCALL_H
#include  <twoncall.h>
#endif

/* 1998/01/29 : |C^staticzɕύX. */
#if 0
static const char rcsid[] = "@(#)dx.c,v 1.4 1995-05-02 04:01:06+0900 kyoko Exp";
static const char rcsname[] = "amy";
#endif
#define RCSNAME "amy"

#define VERSION		"version 1.4"
#define PATCHLEVEL	"patchlevel 3"
#define PATCHDATE	"1998/09/06"
#define PATCHAUTHOR	"Ԃq"


#define TRUE		1
#define FALSE		0
#define ESCAPE		"\\"

typedef unsigned char	UC;
typedef unsigned short	US;
typedef unsigned long	UL;

#ifndef __match_h__
#define __match_h__

#define ANYSTRING	'*'
#define ANYCHAR		'?'
#define LBRACKET	'['
#define RBRACKET	']'
#define RANGE		'-'
#define UNSET		'!'
#define UNSET_OLD	'^'
#define LBRACE		'{'
#define RBRACE		'}'

int	escape_char = '\\';

#define GETCHAR(s, ignore_case) ({	\
    int	    _C;				\
    if (ismbblead(*s)) {		\
	_C = (((UC)s[0] << 8)| (UC)s[1]); \
	s += 2;				\
    } else {				\
	if (ignore_case)		\
	    _C = toupper(s[0]);		\
	else				\
	    _C = s[0];			\
	s++;				\
    }					\
    (_C);				\
})

typedef enum	{ SENSITIVE, INSENSITIVE } CASE;
typedef char	REGEX;

static int match(const char *string, const REGEX *regex, CASE icase);

#endif	/* __match_h__ */


/* Micro soft disk type attribute */
#define MS_RED		0001
#define MS_HID		0002
#define MS_SYS		0004
#define MS_VOL		0010
#define MS_DIR		0020
#define MS_REG		0040
/* Human FSW Localy bit */
#define MS_LNK		0100
#define MS_EXE		0200


/* 2HD ŗL̒l */
#define FATMAGIC_2HD	"\xfe\xff\xff"
#define BLOCKSIZE_2HD	1024			/* 1ZN^̃oCg */
#define SECTOR_2HD	8			/* 1gbÑZN^ */
#define TRACK_2HD	(77*2)			/* gbN */
#define FATSEC_2HD	2			/* FAT̃ZN^ */
#define FATLEN_2HD	(BLOCKSIZE_2HD * FATSEC_2HD)
#define ROOTSEC_2HD	6			/* [gfBNg̃ZN^ */
#define ROOT_ENTRY_2HD	(BLOCKSIZE_2HD * ROOTSEC_2HD / sizeof (DIRENT))
#define FAT_BIAS_2HD	(1 + FATSEC_2HD*2 + ROOTSEC_2HD - 2)
						/* FATԍNX^ԍւ̍ */
/* 2HQ ŗL̒l */
#define FATMAGIC_2HQ	"\xf0\xff\xff"
#define BLOCKSIZE_2HQ	512
#define SECTOR_2HQ	18
#define TRACK_2HQ	(80*2)
#define FATSEC_2HQ	9
#define FATLEN_2HQ	(BLOCKSIZE_2HQ * FATSEC_2HQ)
#define ROOTSEC_2HQ	14
#define ROOT_ENTRY_2HQ	(BLOCKSIZE_2HQ * ROOTSEC_2HQ / sizeof (DIRENT))
#define FAT_BIAS_2HQ	(1 + FATSEC_2HQ*2 + ROOTSEC_2HQ - 2)

/* 2HS ŗL̒l */
#define FATMAGIC_2HS	"\xfb\xff\xff"
#define BLOCKSIZE_2HS	1024
#define SECTOR_2HS	9
#define TRACK_2HS	(80*2)
#define FATSEC_2HS	3
#define FATLEN_2HS	(BLOCKSIZE_2HS * FATSEC_2HS)
#define ROOTSEC_2HS	6
#define ROOT_ENTRY_2HS	(BLOCKSIZE_2HS * ROOTSEC_2HS / sizeof (DIRENT))
#define FAT_BIAS_2HS	(1 + FATSEC_2HS*1 + ROOTSEC_2HS - 2)

/* ̑ FDD ŗL̒l */
#define FATMAGIC_SIZE	3
#define IS_FATEND(x)	((x) >= 0xff8)

/* 1998/01/28 : NX^ԍւ̕ϊ̃}Nōs悤ɂ. */
#define SEEKPTR(o)	((seektable[(o) + FatBias] * BlockSize) + data_offset)

typedef enum {
    FD2HD,
    FD2HQ,
    FD2HS,
    DIM2HD,
    DIM2HQ,
    DIM2HS,
    DCU2HD,
    DCU2HQ
} filetype;

#define DIM_TRACK_MAX	(170)
enum dim_media_type {
    DIM_2HD_ID	= 0x00,
    DIM_2HS_ID	= 0x01,
    DIM_2HC_ID	= 0x02,
    DIM_2HDE_ID	= 0x03,
    DIM_2HQ_ID	= 0x09,
    DIM_N88B_ID	= 0x11
};
typedef struct {
    unsigned char media_type;
    unsigned char track_use_flag[DIM_TRACK_MAX];
    char id[15];	/* .dc.b 'DIFC HEADER  ',0,0 */
    unsigned int date;
    unsigned int time;
    char comment[60];
    unsigned char version;
    unsigned char over_track_flag;
} dim_header;

#define DCU_TRACK_MAX	(161)
enum dcu_media_type {
    DCU_2HD_ID	= 0x01,
    DCU_2HC_ID	= 0x02,
    DCU_2HQ_ID	= 0x03,
    DCU_2DD8_ID	= 0x04,
    DCU_2DD9_ID	= 0x05,
};
typedef struct {
    unsigned char media_type;
    unsigned char track_use_flag[DCU_TRACK_MAX];
} dcu_header;


#define ISMONTHS(m)	((m) >= 0 && (m) <= 11)
#define ISSLASH(p)	('\\' == (p) || '/' == (p))
#define ISPATH(p)	(ISSLASH(p) || ':' == (p))
#define ISDRIVE(p)	(isalpha(p[0]) && ':' == (p[1]))
#define POPATTR(n)	(attrstack[n].attr)
#define POPTIME(n)	(attrstack[n].time)
#define BCD2DIGIT(n)	(((UC)n & 0xf) + ((((UC)n & 0xf0) >> 4) * 10))
#define _XCHMOD(n, a)	(_dos_chmod(n, a))
#define _XMKDIR(n)	(_dos_mkdir(n))
#define _XCREATE(n,a)	(_dos_create(n, a))
#define _XCLOSE(n)	(_dos_close(n))

#define PUSHATTR(p) {			\
    attrstack[indent].attr =		\
	p->attr;			\
    attrstack[indent].time =		\
	REGSTAMP(p);			\
}

#define PUTATTR(p) {			\
    putchar(MS_DIR & p ? 'd' :		\
	    MS_VOL & p ? 'v' :		\
	    MS_LNK & p ? 'l' : '-');	\
    putchar(MS_REG & p ? 'a' : '-');	\
    putchar(MS_SYS & p ? 's' : '-');	\
    putchar(MS_HID & p ? 'h' : '-');	\
    putchar('r');			\
    putchar(MS_RED & p ? '-' : 'w');	\
    putchar(MS_EXE & p ? 'x' : '-');	\
}

#define PUT_EXTMESSAGE(name, mes) {	\
    if (!qopt)				\
	eprintf ("%s%s: %s", outputdir ? : "", name, mes);	\
}

#define REGLEN(length) ({		\
    UL	_L;				\
    _L	= length >> 24;			\
    _L	+= (length >> 8) & 0x00ff00;	\
    _L	+= (length << 8) & 0xff0000;	\
    _L	+= (length << 24);		\
    (_L);				\
})

#define REGSTAMP(p) ({			\
    UL	_T;				\
    _T = ((p->date << 8) |		\
	(p->date >> 8)) & 0xffff;	\
    _T <<= 16;				\
    _T |= ((p->time << 8) |		\
	(p->time >> 8)) & 0xffff;	\
    (_T);				\
})

typedef struct {
    char    name[8];
    char    ext[3];
    char    attr;
    char    extname[10];
    US	    time;
    US	    date;
    US	    start_fat;
    UL	    length;
} DIRENT;

typedef struct {
    char    attr;
    UL	    time;
} ATRSTK;

/* DOS call 𒼐ڌĂł֐ under score Ŏn܂Ă܂ */
static int	exdir(DIRENT *pool, const char *path, const REGEX **reg, int count);
static int	getfatlink(const int fatno, const char *fat);
static void	readdirs(int fat, const char *path, const REGEX **reg, int count);
static void	chkarg (int argc, char *argv[]);
static int	writefile(const DIRENT *pool, char *name);
#ifdef	UTIME_EXIST
static time_t	maketime(const DIRENT *pool);
#endif
static void*	xmalloc (size_t size);
static void*	xrealloc (void* ptr, size_t size);
static void	regtime(struct tm *tp, const DIRENT *pool);
static int	xfseek(FILE *fp, long offset, int whence);
static int	xfread(void *buffer, size_t size, size_t so, FILE *fp);
static int	xfwrite(void *buffer, size_t size, size_t so, FILE *fp);
static void	xfclose(FILE *fp);
static char*	getname (const char *p);
static void	_xmkdir(const char *buffer, const char *last, int stack);
static void	_xutime(const char *name, const UL time);
static void	xchdir(const char *path);
static char*	exist_interactive(char *name);
static void	_signalhandler (int sig);
static void volatile	usage (const int e);
static volatile int	xexit(const int n);


/* 1998/09/02 : fprintf (stderr, ...) -> eprintf (...) */
#if !defined (HAVE_EPRINTF) && !defined (__LIBC__)
#include <stdarg.h>
static int
eprintf (const char* fmt, ...)
{
    int cnt;
    va_list ap;

    va_start (ap, fmt);
    cnt = vfprintf (stderr, fmt, ap);
    va_end (ap);
    return cnt;
}
#endif


#ifndef	LS_V
static char*
month_name (int mon)
{
    static const char months[][4] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
	"---"
    };

    if (!ISMONTHS (mon))
	mon = 12;
    return months[mon];
}
#endif


static char*	This;		/* dx g̎st@C */
static FILE*	fp;
static char	newname[PATH_MAX];
static char*	wfile;
static char*	outputdir;
static char*	ImageFile;
static char**	File;		/* oΏۃt@C̔zւ̃|C^ */
static int	FileNum;	/* z̗vf */

static int	indent;
static char*	Fat;
static char*	tracktable;	/* free() ֎~ */
static short*	seektable;
static ATRSTK*	attrstack;

static filetype	Type;
static int	BlockSize;
static int	Sector;
static int	Track;
static int	FatLen;
static int	RootFiles;
static int	FatBias;
static int	data_offset;
static char*	FatMagic;

static char slash[] = "\\";

static CASE	iopt = SENSITIVE;
static int	jopt = FALSE;
static int	xopt = FALSE;
static int	fopt = FALSE;
static int	qopt = FALSE;
static int	vopt = FALSE;
static int	oopt = FALSE;
static int	popt = FALSE;
static int	nopt = FALSE;
static int	once = FALSE;
static int	copt = FALSE;
static int	Fopt = FALSE;
static int	topt = FALSE;
static int	Copt = FALSE;
static int	Lopt = FALSE;    

static char	multi_period;
static char	special_char;


/* 1998/09/02 : C[W 2HQA2HS ̂ǂł邩𔻕ʂ. */
static filetype
is_2hq_or_2hs (FILE* fp)
{
    char buf[FATMAGIC_SIZE];
    int fd2hq, fd2hs;
    char* ext;

    fd2hq = fd2hs = FALSE;

    xfseek (fp, BLOCKSIZE_2HQ, SEEK_SET);
    xfread (buf, 1, FATMAGIC_SIZE, fp);
    if (memcmp (buf, FATMAGIC_2HQ, FATMAGIC_SIZE) == 0)
	fd2hq = TRUE;

    xfseek (fp, BLOCKSIZE_2HS, SEEK_SET);
    xfread (buf, 1, FATMAGIC_SIZE, fp);
    if (memcmp (buf, FATMAGIC_2HS, FATMAGIC_SIZE) == 0)
	    fd2hs = TRUE;

    xfseek (fp, 0, SEEK_SET);

    if (fd2hq && !fd2hs)
	return FD2HQ;
    if (fd2hs && !fd2hq)
	return FD2HS;

    ext = strrchr (ImageFile, '.');
    if (ext) {
	if (stricmp (ext, ".2hq") == 0)
	    return FD2HQ;
	if (stricmp (ext, ".2hs") == 0)
	    return FD2HS;
    }

    eprintf ("%s: can not decide 2HQ/2HS format: %s\n", This, ImageFile);
    xfclose (fp);
    xexit (1);
    /* NOTREACHED */

    return 0;
}

/* 1998/09/03 : .dim ̌`𔻕ʂ(2HD/2HQ/2HS Ή). */
static filetype
get_dim_type (dim_header* hed)
{
    static const char magic[] = "DIFC HEADER  \0";	/* 15 oCg */

    if (memcmp (magic, hed->id, sizeof magic) == 0) {
	switch (hed->media_type) {
	case DIM_2HD_ID: return FD2HD; /* NOTREACHED */
	case DIM_2HQ_ID: return FD2HQ; /* NOTREACHED */
	case DIM_2HS_ID: return FD2HS; /* NOTREACHED */
	default:
	    break;
	}
    }

    eprintf ("%s: not " /*"2HD"*/ " dim format: %s\n", This, ImageFile);
    xfclose (fp);
    xexit (1);
    /* NOTREACHED */
}

static void
put_dim_info (const char* p)
{
    int y, m, d, h, mm, s;

    p++;  y = *p++;  m  = *p++;  d = *p++;
    p++;  h = *p++;  mm = *p++;  s = *p++;

#ifdef	LS_V
    printf ("%4d-%02d-%02d %02d:%02d:%02d %s\n",
	BCD2DIGIT(y) + 1980, BCD2DIGIT(m), BCD2DIGIT(d),
	BCD2DIGIT(h), BCD2DIGIT(mm), BCD2DIGIT(s), p);
#else
    printf ("%s %2d %02d:%02d:%02d %4d %s\n",
	month_name (BCD2DIGIT(m) - 1), BCD2DIGIT(d),
	BCD2DIGIT(h), BCD2DIGIT(mm), BCD2DIGIT(s),
	BCD2DIGIT(y) + 1980, p);
#endif	/* LS_V */

}


/* 1998/09/04 : .dcu ̌`𔻕ʂ(2HD/2HQ Ή). */
static filetype
get_dcu_type (dcu_header* hed)
{
    filetype type;
    int track_max;
    char* p;
    int i;

    switch (hed->media_type) {
    case DCU_2HD_ID: type = DCU2HD; track_max = TRACK_2HD; break;
    case DCU_2HQ_ID: type = DCU2HQ; track_max = TRACK_2HQ; break;
    default:
	goto error;
	/* NOTREACHED */
    }

    p = hed->track_use_flag;

    /* gbN̓e 0x00A0x01A0xff ̂ꂩ */
    for (i = 0; i < track_max; i++) {
	unsigned char c = *p++;

	if (c != 0x00 && c != 0x01 && c != 0xff)
	    goto error;
    }

    /* Ō 0x01 t */
    if (*p++ != 0x01)
	goto error;

    /* c͑S 0x00 (2HQ ̏ꍇ̓tO͎cȂ) */
    for (i++; i < DCU_TRACK_MAX; i++)
	if (*p++)
	    goto error;

    return type;

error:
    eprintf ("%s: not " /*"2HD"*/ " dcu format: %s\n", This, ImageFile);
    xfclose (fp);
    xexit (1);
    /* NOTREACHED */
}


/* 1998/09/04 : tH[}bg/萔ݒ̏֐. */
static filetype
check_imagefile (FILE* fp)
{
    int len = filelength (fileno (fp));
    int over_track = 0;
    filetype type = 0;

    /* x^ 2HD */
    if (len == (BLOCKSIZE_2HD * SECTOR_2HD * TRACK_2HD))
	type = FD2HD;

    /* x^ 2HQA2HS */
    else if (len == (BLOCKSIZE_2HQ * SECTOR_2HQ * TRACK_2HQ))
	type = is_2hq_or_2hs (fp);

    /* dcu 2HDA2HQ */
    else if ((len & 0x1ff) == sizeof (dcu_header)) {
	dcu_header* hed = xmalloc (sizeof (dcu_header));

	xfread (hed, 1, sizeof (dcu_header), fp);
	type = get_dcu_type (hed);
	tracktable = hed->track_use_flag;
	data_offset = sizeof (dcu_header);
    }

    /* dim 2HDA2HQA2HS */
    else {
	dim_header* hed = xmalloc (sizeof (dim_header));

	xfread (hed, 1, sizeof (dim_header), fp);
	type = get_dim_type (hed);
	if (Copt)
	    put_dim_info ((char*) &hed->date);
	if (hed->over_track_flag)
	    over_track = 1;
	tracktable = hed->track_use_flag;
	data_offset = sizeof (dcu_header);
    }

    switch (type) {
    case  FD2HQ:
    case DIM2HQ:
    case DCU2HQ:
	BlockSize =  BLOCKSIZE_2HQ;
	Sector	  =	SECTOR_2HQ;
	Track	  =	 TRACK_2HQ;
	FatLen	  =	FATLEN_2HQ;
	RootFiles = ROOT_ENTRY_2HQ;
	FatBias	  =   FAT_BIAS_2HQ;
	FatMagic  =   FATMAGIC_2HQ;
	break;
    case  FD2HS:
    case DIM2HS:
	BlockSize =  BLOCKSIZE_2HS;
	Sector	  =	SECTOR_2HS;
	Track	  =	 TRACK_2HS;
	FatLen	  =	FATLEN_2HS;
	RootFiles = ROOT_ENTRY_2HS;
	FatBias	  =   FAT_BIAS_2HS;
	FatMagic  =   FATMAGIC_2HS;
	break;
    case  FD2HD:
    case DIM2HD:
    case DCU2HD:
	BlockSize =  BLOCKSIZE_2HD;
	Sector	  =	SECTOR_2HD;
	Track	  =	 TRACK_2HD;
	FatLen	  =	FATLEN_2HD;
	RootFiles = ROOT_ENTRY_2HD;
	FatBias	  =   FAT_BIAS_2HD;
	FatMagic  =   FATMAGIC_2HD;
	break;
    default:
	/* error!!! */
	break;
    }

    if (over_track)
	Track = DIM_TRACK_MAX;

    return type;
}


/* 1998/09/04 : .dim y .dcu ɑΉ. 啝. */
static void
make_seek_table (void)
{
    short* s = seektable = xmalloc (sizeof (short) * Sector * Track);

    switch (Type) {

    case DIM2HD:
    case DIM2HQ:
    case DIM2HS:
    case DCU2HD:
    case DCU2HQ:
	{
	    char* t = tracktable;
	    int i, j, k = 0;

	    for (i = 0; i < Track; i++)
		for (j = 0; j < Sector; j++)
		    *s++ = (*t++ ? k++ : k);
	}
	break;

    default:	/* FD2HD, FD2HQ, FD2HS */
	{
	    int i;

	    for (i = 0; i < Sector * Track; i++)
		*s++ = i;
	}
	break;

    }

    /* Ȍ tracktable ͕svAmalloc() Ŋmۂ */
    /* AhX̂̂Ƃ͌Ȃ̂ŉ͂Ȃ. */
}


int
main (int argc, char* argv[])
{

    /* 1998/01/28 : $SLASH = '/'̎̂ݔF. */
    {
	char* p = getenv("SLASH");
	if (p && *p++ == (char)'/' && *p == (char)'\0')
	    slash[0] = *--p;
    }

    /* setup `escape_char' */
    {
	UC* e = (UC *)(getenv("ESCAPE") ?: ESCAPE);
	escape_char = GETCHAR(e, FALSE);
    }
    This  = getname (argv[0]);
    attrstack = xmalloc(sizeof(ATRSTK) * 128);

#ifdef	HAVE_TWONCALL_H
    /* 1998/09/03 : twoncall.h gp TwentyOne ̏Ԃ𒲂ׂ */
    if (GetTwentyOneID () == TWON_ID) {
	int flags = GetTwentyOneOptions ();

	if (flags & (1 << TWON_PERIOD_BIT))
	    multi_period = 1;
	if (flags & (1 << TWON_SPECIAL_BIT))
	    special_char = 1;
    }
#endif	/* HAVE_TWONCALL_H */

    /* 1998/09/03 : 啝ɍH. */
    {
	char* p = getenv ("DXINIT");
	if (p && *p)
	    chkarg (1, &p);
	chkarg (argc - 1, argv + 1);
    }
    if (!ImageFile) {		/* C[Wt@Cw */
	usage (1);
	/* NOTREACHED */
    }
    if (!FileNum) {		/* ot@CwȂSđΏ */
	char* p = "*";
	File = &p;
	FileNum++;
#if 0
	xopt = FALSE;
#endif
    }

    /* 1998/09/03 : xchdir()  fopen() 悤ɂ. */
    signal(SIGINT, _signalhandler);

    if (NULL == (fp = fopen(ImageFile, "rb"))) {
	eprintf ("%s: can not open: %s\n", This, ImageFile);
	xexit(1);
	/* NOTREACHED */
    }
    if (outputdir)
	xchdir (outputdir);

    /* tH[}bg */
    Type = check_imagefile (fp);

/* ꊇǂݍ݃obt@̊m. ꗗ\͖̎ʂȓǂݍ݂ */
/* ̂ŊmۂȂ. AۂɍsƈُɒxȂ̂ */
/* RgAEgĂ. */
#if defined (LARGE_BUFFER) && 0
    if (xopt) {
	int len = filelength (fileno (fp));
	char* buff = malloc (len);
	char* dumy = malloc (256*1024);	/* \ȋ󂫃ȂΊmۂȂ */

	if (buff && dumy && fflush (fp) == 0)
	    setvbuf (fp, buff, _IOFBF, len);
	else
	    free (buff);
	free (dumy);
    }
#endif

    /* FATǂݍ. */
    Fat = xmalloc (FatLen);
    xfseek (fp, BlockSize, SEEK_CUR);		/* SKIP IPL */
    xfread (Fat, sizeof (char), FatLen, fp);	/* read FAT */

    /* 1998/09/04 : 2HS ͑ FAT Ȃ. */
    if (Type != FD2HS && Type != DIM2HS)
	xfseek (fp, FatLen, SEEK_CUR);		/* SKIP FAT2 */

    /* 1998/01/28 : strncmp()ł͂Ȃmemcmp()g悤ɕύX. */
    if (!fopt && memcmp (Fat, FatMagic, FATMAGIC_SIZE)) {
	const char* fmt = (Type == FD2HQ) ? "2HQ" :
			  (Type == FD2HS) ? "2HS" : "2HD";

	eprintf ("%s: not %s image file: %s\n", This, fmt, ImageFile);
	xfclose(fp);
	xexit(1);
	/* NOTREACHED */
    }

#if 0	/* 1998/01/29 : 1t@Cł͂ȂŐݒ. . */
    fmode (stdout, _IOBINARY);
#endif

    {	/* 1998/01/29 : root dir.obt@Ŋmۂ悤ɂ. */
	DIRENT* pool = xmalloc (sizeof (DIRENT) * (RootFiles + 1));
	pool[RootFiles].name[0] = '\0';

	xfread (pool, sizeof(char), sizeof (DIRENT) * RootFiles, fp);
					/* read Directory Entry */
	make_seek_table ();
	exdir(pool, "", (const REGEX **)File, FileNum);
	xfclose(fp);
#if 0
	free (pool);
	free (Fat);
	free (seektable);
#endif
    }

    xexit(0);
    /* NOTREACHED */
    return 0;
}


/* 1998/09/04 : chopslash() 폜đɐV. */
static char*
add_slash (char* name)
{
    char last;
    char* p;

    /* Ō̕ */
    for (last = 0, p = name; *p;) {
	last = *p++;
	if (ismbblead (last) && *p)
	    p++;
    }

    /* pXf~^ŏIĂȂΕt */
    if (!ISPATH (last)) {
	*p++ = *slash;
	*p = 0;
    }

    return name;
}


/* 1998/09/03 : ImageFile, File, FileNum, outputdir ֌W */
/*		    ύXɔ啝ɏ. */
static void
chkarg (int argc, char *argv[])
{

    while (--argc >= 0) {
	char* p = *argv++;

	if ((char)'-' == *p) {
	    p++;
	    while (*p) {
		switch (*p++) {
		case	'V':	/* print original version */
		    printf ("dx: version " RCSNAME " (C) 1995 fubuki\n");
		    xexit (0);
		    /* NOTREACHED */
		case	'/':	/* option all clear */
		    iopt = SENSITIVE;
		    Fopt = Copt = qopt = jopt = fopt = \
		    popt = copt = vopt = Lopt = xopt = \
		    oopt = nopt = topt = once = FALSE;
		    free (outputdir);
		    outputdir = NULL;
		    break;
		case	'i':	/* p^[ő啶 */
		    iopt = INSENSITIVE;
		    break;
		case	'F':	/* ls -F Ɠ */
		    Fopt = TRUE;
		    break;
		case	'C':	/* dim ̂ƂRgo */
		    Copt = TRUE;
		    break;
		case	'q':	/* ܂ */
		    qopt = TRUE;
		    break;
		case	'p':	/* stdout ֕\ */
		    popt = TRUE;
		    /* fall through */
		case	'j':	/* Xn (mkdir Ȃ) */
		    jopt = TRUE;
		    /* fall through */
		case	'x':	/* o */
		case	'e':
		    xopt = TRUE;
		    break;
		case	'f':	/* ۏ */
		    fopt = TRUE;
		    break;
		case	'c':	/* Human g filename(10)؂̂ */
		    copt = TRUE;
		    break;
		case	'v':	/* volume label o */
		    vopt = TRUE;
		    break;
		case	'L':	/* VFAT Ot@Cl[o(퓮삵Ȃ) */
		    Lopt = TRUE;
		    break;
		case	'o':	/*  over write */
		    oopt = TRUE;
		    break;
		case	'n':	/*  skip */
		    nopt = TRUE;
		    break;
		case	't':	/* tree list */
		    topt = TRUE;
		    /* fall through */
		case	'1':	/* Xg */
		    once = TRUE;
		    /* fall through */
		case	'l':	/* Xg (l) */
		    xopt = FALSE;
		    break;
		case	'd':	/* o path w */
		    while (!*p) {
			if (--argc < 0) {
			    usage (1);
			    /* NOTREACHED */
			}
			p = *argv++;
		    }
		    outputdir = add_slash (strcpy (xmalloc (strlen (p) + 2), p));
		    goto down;
		case	'-':	/* --version, --help */
		    if (0 == strcmp (p, "version")) {
			printf ("dx " VERSION " " PATCHLEVEL "\n");
			xexit (0);
			/* NOTREACHED */
		    }
		    if (0 == strcmp (p, "help")) {
		case	'?':
		case	'h':
		case	'H':
			usage (0);
			/* NOTREACHED */
		    }
		    /* fall through */
		default:
		    usage (1);
		    /* NOTREACHED */
		}
	    }	/* end while */

	} else {
	    if (!ImageFile)
		ImageFile = p;
	    else {
		if ((FileNum & 0xf) == 0)
		    File = xrealloc (File, (FileNum + 0x10) * sizeof (char*));
		File[FileNum++] = p;
	    }
	}
down:
    }
}

static void
_xmkdir(const char *buffer, const char *last, int stack)
{
    char  tmp[PATH_MAX];
    char* q = tmp;
    const char* p;

    for (p = buffer; *p;) {
	/* 1998/09/02 : oCgsyуpXf~^ */
	/*		    ̌ԈĂsC.		   */
	if (ismbblead (p[0]) && p[1])
	    *q++ = *p++;
	else if (p > last && ISSLASH (*p)) {
	    *q = '\0';
	    if (0 == _XMKDIR (tmp)) {
		PUT_EXTMESSAGE (tmp, "succeed\n");
		_XCHMOD (tmp, POPATTR (stack));
		_xutime (tmp, POPTIME (stack));
	    }
	    _xmkdir (buffer, p, ++stack);
	    return;
	}
	*q++ = *p++;
    }
}

#ifndef	UTIME_EXIST
static void
_xutime(const char *name, const UL tstamp)
{
    FILE    *p;
    UL	    a;

    a = _XCHMOD(name, -1);
    _XCHMOD(name, MS_REG);
    p = fopen(name, "a");
    _dos_filedate(fileno(p), tstamp);
    fclose(p);
    _XCHMOD(name, a);
}
#endif /* UTIME_EXIST */


static int
is_through (unsigned char c)
{
    /* 䕶 */
    if (c <= 0x20 || 0xfc < c || c == 0x7f)
	return 0;

    /* ɎgȂL */
    if (strchr ("*./:?\\", c))
	return 0;

    /* TwentyOne -s ŎgȂL(+s Ȃg) */
    if (!special_char && strchr ("\"'+^_{}~", c))
	return 0;

    /* }`sIh */
    if (!multi_period && (unsigned char)'.' == c)
	return 0;

    /* ȊO͎gp\ȋLApAЉ */
    return 1;
}


static int
regname (char *p, const int dotpoint)
{
    int f = FALSE;
    int i;
    char c;

#ifdef __HUMAN68K__
    if (!special_char && (char)'-' == *p) {
	*p = '_';
	f = TRUE;
    }
#endif

    for (i = 0; (c = *p++); i++) {
	if (i == dotpoint)
	    continue;
	if (ismbblead (c) && *p)
	    p++;
	else if (!is_through (c)) {
	    p[-1] = '_';
	    f = TRUE;
	}
    }
    return f;
}

static char*
delspace (char* p, char* top)
{
    char c;
    do {
	c = *--p;
    } while ((top < p) && (c == (char)' '));
    return ++p;
}

/*
    т̖{(т)
 */
static int
exdir(DIRENT *pool, const char *path, const REGEX **reg, int count)
{
    char    buffer[256];
    char    *p, *q, *pathterm;
    int	    i, cond, dotpoint;

    strcpy(buffer, path);
    if (*path)
	strcat (buffer, slash);
    pathterm = &buffer[strlen(buffer)];
    while(0 != pool->name[0]) {
	if (((char)'\xe5' == pool->name[0]) || (0x0f == pool->attr && !Lopt)) {
	    pool++;
	    continue;
	}

	q = pathterm;
	p = pool->name;

	/* 1998/01/29 : t@C̒o. */
	for (i = 8; --i >= 0;)			/* t@C1(c' ') */
	    *q++ = *p++;
	if (*pathterm == (char)'\x05')
	    *pathterm = '\xe5';
	p = pool->extname;
	if (!*p)
	    q = delspace (q, pathterm);		/* ̋󔒂폜. */
	else {
	    if (!copt) {
		for (i = 10; (--i >= 0) && *p;)	/* t@C2(c'\0') */
		    *q++ = *p++;
	    } else {
		p = pathterm;			/* t@C2͖. */
		while (p < q)
		    p += ismbblead (*p) ? 2 : 1;
		if (p > q)	/* 8-9oCgڂɓoCgʃo */
		    q--;	/* CgcĂ܂̂ŁA폜  */
	    }
	}
	p = pool->ext;
	dotpoint = -1;
	if (' ' != *p) {
	    dotpoint = q - pathterm;
	 /* if (!(MS_VOL & pool->attr) || ((MS_VOL & pool->attr) && xopt)) */
		*q++ = '.';
	    for (i = 3; --i >= 0;)		/* gq */
		*q++ = *p++;
	    q = delspace (q, q - 3);
	}
	*q = '\0';

	if (0 == (strcmp(pathterm, ".")) ||
	    0 == (strcmp(pathterm, ".."))) {
	    pool++;
	    continue;
	}

	for(i = 0; i < count; i++)
	if (match(buffer, reg[i], iopt)) {
	    *newname = 0;
	    cond = FALSE;
	    if (xopt) {
		if(regname(pathterm, dotpoint))
		    fputs("regular... ", stderr);

		if (MS_VOL & pool->attr) {
		    /* {[x */
		    if (vopt) {
			char* volname = exist_interactive (buffer);
			int fd = _XCREATE (volname, MS_VOL);
			if (fd >= 0) {
			    _XCLOSE (fd);
			    cond = TRUE;
			}
			PUT_EXTMESSAGE (buffer, cond ? "succeed\n" : "failure\n");
		    }
		} else if (MS_DIR & pool->attr) {
		    /* fBNg */
		    if (!jopt) {
			if (indent)
			    _xmkdir (buffer, buffer, 0);
			if (0 == _XMKDIR (buffer))
			    cond = TRUE;
			PUT_EXTMESSAGE (buffer, cond ? "succeed\n" : "failure\n");
		    }
		} else {
		    /* t@C */
		    if (!jopt && indent)
			_xmkdir (buffer, buffer, 0);
		    cond = writefile(pool, jopt ? getname (buffer) : buffer);
		}
		if (cond && !popt) {
#ifdef	UTIME_EXIST
		    struct utimbuf tm;
		    tm.modtime = tm.actime = maketime(pool);
		    utime(*newname ? newname :
			    jopt ? getname (buffer) : buffer, &tm);
		    /*
			libc  utime  [N21?
			̂ŁAƂ肠ȉœ
		    */
#else	/* Human Local */
		    _xutime(*newname ? newname :
			    jopt ? getname (buffer) : buffer, REGSTAMP(pool));
#endif
		}
		if (0 == (pool->attr & MS_VOL)) {
		    _XCHMOD(*newname ? newname :
			    jopt ? getname (buffer) : buffer, pool->attr);
		}
	    } else {	/* if (!xopt) */
		if (!once) {
		    struct tm tp;
		    PUTATTR(pool->attr);
		    printf (" %7d ", (int)REGLEN (pool->length));
		    regtime(&tp, pool);
#ifdef	LS_V
		    printf ("%4d-%02d-%02d %02d:%02d:%02d ",
			tp.tm_year + 1900, tp.tm_mon + 1, tp.tm_mday,
			tp.tm_hour, tp.tm_min, tp.tm_sec
		    );
#else
		    printf ("%s %2d %02d:%02d:%02d %4d ",
			month_name (tp.tm_mon), tp.tm_mday,
			tp.tm_hour, tp.tm_min, tp.tm_sec,
			tp.tm_year + 1900
		    );
#endif	/* LS_V */
		}
		if (topt) {
		    int i;
		    if (MS_DIR & pool->attr) {
			fputs("|", stdout);
			for (i = indent; i--;)
			    fputs("   |", stdout);
			putchar('\n');
		    }
		    for (i = indent; i--;)
			fputs("|	  ", stdout);
		    printf("|- %s", getname (buffer));
		} else
		    fputs(buffer, stdout);
		if (Fopt) {
#ifdef	LS_LIKE
		    int	    a = MS_DIR & pool->attr ? *slash :
				MS_LNK & pool->attr ? '@'    :
				MS_EXE & pool->attr ? '*'    : 0;
		    if (a) putchar(a);
		    if (match(buffer, "*.[xr]", INSENSITIVE) && a != '*')
			putchar('*');
#else
		    if (MS_DIR & pool->attr)
			putchar (*slash);
#endif /* LS_LIKE */
		}

		putchar('\n');
	    }
	} /* for loop end */
	if (MS_DIR & pool->attr) {
	    US	f = pool->start_fat >> 8 | pool->start_fat << 8;
	    PUSHATTR(pool);
	    indent ++;
	    readdirs(f, buffer, reg, count);
		/* ̊֐̒Ō݂̊֐ċAI call Ă */
	    indent --;
	}
	pool++;
    }
    return 0;
}


static char*	input_answer (char* buf, size_t size);

static char*
exist_interactive (char* name)
{
    char  buffer[32];
    FILE* fp;

    if (nopt)
	return NULL;
    if (NULL == (fp = fopen (name, "r")))
	return name;
    fclose (fp);

    eprintf ("writable %s exists; remove it? [nyr](n): ", name);
    input_answer (buffer, sizeof buffer);
    switch (*buffer) {
    case 'r':
	eprintf ("new name: %s -> ", name);
	do {
	    input_answer (newname, sizeof newname);
	} while (*newname == '\0');
	name = exist_interactive (newname);
	break;

    case 'y':
#ifdef	FORCE_WRITE
	if ((MS_RED|MS_HID|MS_SYS|MS_VOL) & _XCHMOD (name, -1)) {
	    _XCHMOD (name, MS_REG);
	    unlink (name);
	}
#endif	/* FORCE_WRITE */
	break;

 /* case 'n': */
    default:
	name = NULL;	/* "checkout aborted" */
	break;
    }
    return name;
}

static char*
input_answer (char* buf, size_t size)
{
    char* p = fgets (buf, size, stdin);

    if (p) {
	char* lf = strchr (p, '\n');
	if (lf)
	    *lf = '\0';
    }
    return p;
}


static int
writefile (const DIRENT* pool, char* name)
{
    FILE    *fpw;
    US	    fat = pool->start_fat >> 8 | pool->start_fat << 8;
    int l;
#ifdef	LARGE_BUFFER
    char* buff = NULL;
#endif

    if (!oopt && !popt) {
	if (NULL == (name = exist_interactive(name))) return FALSE;
    }
    if (popt) {
	fpw = stdout;
    } else {
	if (NULL == (fpw = fopen(name, "wb"))) {
	    eprintf ("%s%s: failure\n", outputdir ? : "", name);
#ifdef	CONTINUE
	    return FALSE;
#else
	    xexit(1);
	    /* NOTREACHED */
#endif
	}
	/* ݏ݃I[vĂt@C signalpɕێ */
	wfile = name;
    }
    PUT_EXTMESSAGE(name, "");

    l = REGLEN (pool->length);
#ifdef	LARGE_BUFFER
    if (!popt && l > BUFSIZ) {
	char* dumy;
	buff = malloc (l);
	dumy = malloc (256*1024);	/* \ȋ󂫃ȂΊmۂȂ */
	if (buff && dumy && fflush (fpw) == 0)
	    setvbuf (fpw, buff, _IOFBF, l);
	else {
	    free (buff);
	    buff = NULL;
	}
	free (dumy);
    }
#endif

    if (l) {				/* 0oCgȂo͕sv. */
	char* buffer = xmalloc (BlockSize);
	int verbose = FALSE;
	int s = BlockSize;
	int n = 0;

	if ((1024 * 100) < l)		/* 100KBȂoߕ\. */
	    verbose = TRUE;

	fflush (stderr);
	do {
	    xfseek (fp, SEEKPTR (fat), SEEK_SET);
	    if (l < BlockSize)
		s = l;
	    xfread (buffer, sizeof (char), s, fp);
	    if (FALSE == xfwrite (buffer, sizeof (char), s, fpw)) {
#ifdef	LARGE_BUFFER
		free (buff);
#endif
		return FALSE;
	    }
	    if (!qopt && verbose && (0 == n % 32)) {
		fputc ('.', stderr);
		fflush (stderr);
	    }
	    l -= s;
	    n++;
	} while (!IS_FATEND (fat = getfatlink (fat, Fat)));
    }

    if (!qopt)
	fputs (" succeed\n", stderr);
    if (!popt)
	xfclose (fpw);
#ifdef	LARGE_BUFFER
    free (buff);
#endif
    return TRUE;
}

static void
readdirs (int fat, const char* path, const REGEX** reg, int count)
{
    int fats = fat;
    int n = 1;
    char* sub;
    char* p;

    /* fBNg̒𒲂ׂāAobt@mۂ. */
    while (!IS_FATEND ((fats = getfatlink (fats, Fat))))
	n++;
    p = sub = xmalloc ((BlockSize * n) + 1);

    do {
	xfseek (fp, SEEKPTR (fat), SEEK_SET);
	xfread (p, sizeof (char), BlockSize, fp);
	p += BlockSize;
    } while (!IS_FATEND ((fat = getfatlink (fat, Fat))));

    sub[BlockSize * n] = 0;
    exdir ((DIRENT*) sub, path, reg, count);
    free (sub);
}

/* 12bit FAT only */
static int
getfatlink (const int fatno, const char* fat)
{
    const unsigned char* p = fat;
    const int off = fatno + (fatno >> 1);

    return (fatno & 1) ? (p[off + 1] << 4) + (p[off] >> 4)
		       : ((p[off + 1] & 0xf) << 8) + p[off];
}

static void
regtime (struct tm* tp, const DIRENT* pool)
{
    tp->tm_sec =  ((pool->time >> 8) & 037) * 2;
    tp->tm_min =   (pool->time >> 13) | ((pool->time << 3) & 070);
    tp->tm_hour =  (pool->time >> 3 ) & 037;
    tp->tm_mday =  (pool->date >> 8) & 037;
    tp->tm_mon = (((pool->date >> 13) & 07) | ((pool->date << 3) & 010)) - 1;
    tp->tm_year = ((pool->date >> 1) & 0177) + 80;
    tp->tm_isdst = -1;
}

#ifdef	UTIME_EXIST
static time_t
maketime (const DIRENT* pool)
{
    struct tm n;

    regtime (&n, pool);
    return mktime (&n);
}
#endif /* UTIME_EXIST */


/* 1998/09/03 : xrealloc() ̒ǉyя. */
static void*
xmalloc (size_t size)
{
    void* p = malloc (size);

    if (!p) {
	eprintf ("%s: memory exhausted\n", This);
	xexit(1);
	/* NOTREACHED */
    }
    return p;
}
static void*
xrealloc (void* ptr, size_t size)
{
    void* p = realloc (ptr, size);

    if (!p) {
	eprintf ("%s: memory exhausted\n", This);
	xexit(1);
	/* NOTREACHED */
    }
    return p;
}


static int
xfseek (FILE* fp, long offset, int whence)
{
    int n = fseek (fp, offset, whence);

    if (n < 0) {
	eprintf ("%s: file seek error\n", This);
	xexit (1);
	/* NOTREACHED */
    }
    return n;
}

static int
xfread (void* buffer, size_t so, size_t size, FILE* fp)
{
    int n = fread (buffer, so, size, fp);

    if ((n < (so * size)) || ferror (fp)) {
	eprintf ("%s: file read error\n", This);
	fclose (fp);
	xexit (1);
	/* NOTREACHED */
    }
    return n;
}

static int
xfwrite (void* buffer, size_t so, size_t size, FILE* fp)
{
    int n = fwrite (buffer, so, size, fp);

    if ((n < (so * size)) || ferror (fp)) {
#ifdef	CONTINUE
	fputs (" failure\n", stderr);
	n = FALSE;
	fclose (fp);
	if (wfile)
	    unlink (wfile);
	wfile = NULL;
#else
	eprintf ("%s: file write failure\n", This);
	fclose (fp);
	if (wfile)
	    unlink (wfile);
	xexit(1);
	/* NOTREACHED */
#endif /* CONTINUE */
    } else
	n = TRUE;
    return n;
}

static void
xfclose (FILE* fp)
{
    if (fclose (fp)) {
	eprintf ("%s: file close failure\n", This);
	xexit (1);
	/* NOTREACHED */
    }
    wfile = NULL;
}

static int
match (const char* str, const REGEX *ptn, CASE icase)
{
    while(*ptn) {

	/* ꂪȂ "ZIP"  "*P?*" Ȃǂ}b`Ă܂ */
	if ('\0' == *str && ANYSTRING != *ptn)
	    return FALSE;

	switch(*ptn) {

	case	ANYCHAR:
	    ptn++;
	    if (ismbblead(*str) && str[1])
		str += 2;
	    else
		str++;
	    break;
	case	ANYSTRING:
	    ptn++;
	    while(*str) {
		if (match(str, ptn, icase)) return TRUE;
		if (ismbblead(*str) && str[1]) str++;
		str++;
	    }
	    if (match("", ptn, icase)) return TRUE;
	    return FALSE;
	    break;
#if defined(METASLASH) && defined(METABACKSLASH)
	/*
	    METASLASH = / , METABACKSLASH = \ ɂ邱Ƃɂ
	    "/"  "\"  "/" ɂ "\" ɂ}b`郁^ɂȂ
	     ESCAPE  "\" ȊOɕύXȂ΂Ȃ
	*/
	case	METASLASH:
	case	METABACKSLASH:
	    if (!ISSLASH(*str)) return FALSE;
	    str++;
	    ptn++;
	    break;
#endif /* METASLASH && METABACKSLASH */
	case	LBRACKET:
	{
	    int	    cc, c, h, l, not = FALSE, cnd = FALSE;
	    ptn++;
	    if (UNSET_OLD == *ptn || UNSET == *ptn) {
		ptn++;
		cnd = not = TRUE;
	    }
	    c = GETCHAR(str, icase);
	    if (RBRACKET == *ptn && RBRACKET == c) {
		cnd = !cnd;
		ptn++;
		while(RBRACKET != *ptn && *ptn) {
		    if (ismbblead(*ptn) && ptn[1]) ptn++;
		    ptn++;
		}
		goto down;
	    }
	    while(RBRACKET != *ptn && *ptn) {
		h = l = GETCHAR(ptn, icase);
		if (RANGE == *ptn) {
		    ptn++;
		    if (RBRACKET == *ptn || '\0' == *ptn) return FALSE;
		    h = GETCHAR(ptn, icase);
		}
		cc = not ? !(c >= l && c <= h) : (c >= l && c <= h);
		if (not) {
		    cnd &=  cc;
		} else if (cc) {
		    cnd = cc;
		    while(RBRACKET != *ptn && *ptn) {
			  if (ismbblead(*ptn) && ptn[1]) ptn++;
			  ptn++;
		    }
		    break;
		}
	    }
down:
	    if ((RBRACKET != *ptn++) || (!cnd)) return FALSE;
	    break;
	}
#if defined(LBRACE) && defined(RBRACE)
	case	LBRACE:
	{
	    const char	*p, *q;
	    int	    mt, wp, ws;
	    if (!*str) return FALSE;
	    q = p = str;
	    ptn++;
	    do {
		str = p;
		mt = TRUE;
		do {
		    if ('\0' == *ptn) return FALSE;
		    ws = GETCHAR(str, icase);
		    wp = GETCHAR(ptn, icase);
		    if (ws != wp) {
			mt = FALSE;
			while(RBRACE != *ptn && ',' != *ptn && *ptn) {
			    if (ismbblead(*ptn) && ptn[1]) ptn++;
			    ptn++;
			}
		    }
		} while (RBRACE != *ptn && ',' != *ptn);
		if (TRUE == mt && str - p > q - p) {
		    q = str;
		}
		if (',' == *ptn) ptn++;
	    } while (RBRACE != *ptn);
	    if (q == p) return FALSE;
	    ptn++;
	    str = q;
	    break;
	}
#endif /* defined(LBRACE) && defined(RBRACE) */
	default:
	{
	    int	    p, s;
	    p = GETCHAR(ptn, icase);
	    s = GETCHAR(str, icase);
	    if (escape_char == p) p = GETCHAR(ptn, icase);
	    if (p != s) return FALSE;
	    break;
	}

      }
    }
    return *str ? FALSE : TRUE;
}


static char*
_getpwd (void)
{
#ifdef	HAVE_PWD_ENV
    return getenv ("PWD");
#else
    static char buf[PATH_MAX];
    char* p = buf;

    *p++ = _dos_curdrv () + 'A';
    *p++ = ':';
    *p++ = *slash;
    _dos_curdir (0, p);

    for (p = buf; *p; p++) {
	if (ismbblead (p[0]) && p[1])
	    p++;
	else if (ISSLASH(*p))
	    *p = *slash;
    }
    return buf;
#endif	/* !HAVE_PWD_ENV */
}

/* 1998/01/28 : "-" ł͂Ȃ NULL  oldpwd Ɉړ悤ɕύX. */
/* 1998/09/03 :  xchdir(0) ͖ċA. */
static void
xchdir (const char* path)
{
    static char oldpwd[PATH_MAX];

    if (!path) {
	path = (const char *)oldpwd;
	if (!path[0])
	    return;
    }
    strcpy (oldpwd, _getpwd ());
    if (-1 == chdir (path)) {	/* : JghCuύX chdir */
	switch (errno) {
	case ENOENT:
	    eprintf ("%s: directory not found: %s\n", This, path);
	    break;
	case ENOTDIR:
	    eprintf ("%s: bad directory name: %s\n", This, path);
	    break;
	case ELOOP:
	    eprintf ("%s: deep nest symbolic link: %s\n", This, path);
	    break;
	default:
	    break;
	}
	xexit(1);
	/* NOTREACHED */
    }
}


static char*
getname (const char* p)
{
    const char* last = p;
    int c;

    while ((c = *p++)) {
	if (ismbblead (c) && p[1])
	    p++;
	else if (ISPATH (c))
	    last = p;
    }
    return (char*) last;
}


static volatile void
usage (const int e)
{
    /*
	ŕ\ȂIvVgpꍇ
	x DOS ɑ΂mȂƁAn}ɂƂł傤B
	˂Ďgpꍇ͊e̐ӔCɉĎgpĂB
    */

    (e ? eprintf : printf) (
	"dx " VERSION " " PATCHLEVEL " (C)1995 fubuki, " PATCHDATE " " PATCHAUTHOR ".\n"
	"usage: %s [-l1tpxeijcqnoCFV/] [-d outputdir] imagefile [extfile] ...\n",
	This);

    xexit (e);
}


static void
_signalhandler (int sig)
{
    fcloseall ();
    if (!popt && wfile)
	_dos_delete (wfile);
    if (outputdir)
	xchdir (0);
    _dos_print ("aborted.\r\n");
    xexit (2);
}


static volatile int
xexit (const int n)
{
    if (outputdir)
	xchdir (0);
    exit (n);
}


/*** dx.c ***/
